import { useDropzone } from 'react-dropzone';
import { useEffect } from 'react';

function DropZoneForFiles ({props, onLoad}) {
    const {acceptedFiles, getRootProps, getInputProps} = useDropzone();
    useEffect(() => {
      if(acceptedFiles[0]){
          onLoad(acceptedFiles[0])
      }
    },[acceptedFiles[0]])
    const files = acceptedFiles.map(file => (
      <li key={file.path}>
        {file.path} - {file.size} bytes
      </li>
    ));
  
    return (
      <section className="container">
        <div {...getRootProps({className: 'dropzone'})}>
          <input {...getInputProps()} />
          <p>Drag 'n' drop some files here, or click to select files</p>
        </div>
        <aside>
          <h4>Files</h4>
          <ul>{files}</ul>
        </aside>
      </section>
    );
  }

  export default DropZoneForFiles;