import { useState } from "react";
import { connect } from "react-redux";
import { actionFullLogin } from "../../actions";
import {Link} from "react-router-dom"

const Login = ({onLogin}) => {
       const[login,setLogin] = useState('');
       const[password,setPassword] = useState(''); 
    return (
        <div className="min-h-full flex items-center justify-center py-12 px-4 sm:px-6 lg:px-8">
                <div className="max-w-md w-full space-y-8">
                        <div>
                            <h2 className="mt-6 text-center text-3xl font-extrabold text-gray-900">Login</h2>
                        </div>
                        <div className="mt-8 space-y-6 rounded-md shadow-sm ">
                            <div>
                            <label>Login:</label>
                            <input placeholder="login" value={login} type="text" className="LoginInput" onChange={event => setLogin(event.target.value)}/>
                            </div>
                            <div>
                            <label>Password:</label>
                            <input placeholder="password" value={password} type="password" className="LoginInput" onChange={event => setPassword(event.target.value)}/>
                            </div>
                            <div className="text-gray-400">
                            You dont have account? 
                                <Link  className="text-gray-600 hover:underline hover:text-fuchsia-600" to="/register"> Create!</Link>
                            </div>
                           <button className="LoginButton" onClick={()=> onLogin(login,password)}>Login</button>
                        </div>
                </div>
        </div>
    )
}

const CLoginForm = connect(null, {onLogin: actionFullLogin})(Login)

export default CLoginForm;