import {Route,Redirect, Switch} from 'react-router-dom';
import Feed from '../Feed/Feed';
import User from '../UserPage/User';
import Collections from '../CollectionsPage/Collections';
import UpsertPost from '../CreatePostPage/UpsertPost';
import UserSettings from '../UserSettings/UserSettings';
import { actionAboutMe } from '../../actions';
import { useEffect } from 'react';
import { connect } from 'react-redux';
import store from '../../reducers';

const Main = ({auth}) => {
    console.log(auth)
useEffect(()=>{
    
    store.dispatch(actionAboutMe(auth));
})

    return(
        <div className='flex mx-auto px-4 justify-between p-6 xl:container xls:mx-auto'>
            <Switch>
                <Route path="/" exact component={Feed}/>
                <Route path="/user/:id" exact component={User}/>
                <Route path="/settings" exect component={UserSettings}/>
                <Route path="/collections" exact component={Collections}/>
                <Route path="/createpost" exact component={UpsertPost}/>
            </Switch>
        </div>
    )
} 



const CMain = connect(state =>({auth: state.auth?.payload?.sub?.id || []}))(Main);



export default CMain;