import { useEffect, useState } from "react";
import { connect } from "react-redux";
import { Link } from "react-router-dom";
import { actionFullRegister } from "../../actions";

const Register = ({onRegister}) => {

    const [login, setLogin] = useState('');
    const [password, setPassword] = useState('');
    const [confpassword, setConfPassword] = useState('');
    const [errmsg, setErrMsg] = useState('');
    useEffect(() => {
        const min = 4;
        const pswdPattern = /^[0-9a-zA-Z]+$/;
        if(password.length > min && confpassword.length > min && password.match(pswdPattern)&& confpassword.match(pswdPattern) && password === confpassword){
            console.log("all ok")
            setErrMsg("");
    } else {
        setErrMsg("password not match");
    } 
    },[password,confpassword])
   /*  */
    return(
        <div className="min-h-full flex items-center justify-center py-12 px-4 sm:px-6 lg:px-8">
        <div className="max-w-md w-full space-y-8">
                <div>
                    <h2 className="mt-6 text-center text-3xl font-extrabold text-gray-900">Register</h2>
                </div>
                <div className="mt-8 space-y-6 rounded-md shadow-sm ">
                    <div>
                    <label>Login:</label>
                    <input placeholder="login" value={login} type="text" className="LoginInput" name="login" onChange={(event) => {setLogin(event.target.value)}}/>
                    </div>
                    <div>
                    <label>Password:</label>
                    <input placeholder="password" value={password} type="password" className="LoginInput" name="password" onChange={(event) => {setPassword(event.target.value)}}/>
                    </div>
                    <div>                    
                    <label>Confirm Password:</label>
                    <input placeholder="password" value={confpassword} type="password" className="LoginInput" name="confpassword" onChange={(event) => {setConfPassword(event.target.value)}}/>
                    </div>
                    <label className="text-red-400">
                            {errmsg}
                    </label>
                    <div className="text-gray-400">
                    You have account? 
                        <Link  className="text-gray-600 hover:underline hover:text-fuchsia-600" to="/login"> Login</Link>
                    </div>
                   <button className="LoginButton" disabled={errmsg} onClick={() => onRegister(login,password) }>Register</button>
                </div>
        </div>
</div>
    )


}

const CRegister = connect(state => ({errorFromServer: state.promise?.fullRegister?.error || []}),{onRegister: actionFullRegister})(Register);



export default CRegister;